//
//  CustomerData.swift
//  FlexGrid101
//
//  Copyright (c) 2015 GrapeCity. All rights reserved.
//

import UIKit

class CustomerData: NSObject {
    var customerID, countryID, performance : Double
    var first, last : String
    var active : Bool
    var hireDate : NSDate
    init(customerID: Double, countryID: Double, performance: Double, first: String, last: String, active: Bool, hireDate: NSDate){
        self.customerID = customerID
        self.countryID = countryID
        self.performance = performance
        self.first = first
        self.last = last
        self.active = active
        self.hireDate = hireDate
    }
    class func generateRandomBool() -> Bool{
        let random = (Int(arc4random_uniform(UInt32(RAND_MAX))))
        if (random % 5 == 0) {
            return true
        }
        else{
            return false
        }
    }
    class func generateRandom(max: Int) -> Int{
        return (Int(arc4random_uniform(UInt32(max))))
    }
    enum Error: ErrorType{
        case lessThanZero
        case equalsZero
    }
    class func getCustomerData(total: Int) throws -> NSMutableArray{
        guard total > 0 else {throw Error.lessThanZero}
        guard total != 0 else {throw Error.equalsZero}
        let array = NSMutableArray()
        let firstNames : String = "Andy|Ben|Charlie|Dan|Ed|Fred|Gil|Herb|Jack|Karl|Larry|Mark|Noah|Oprah|Paul|Quince|Rich|Steve|Ted|Ulrich|Vic|Xavier|Zeb"
        let firstNamesArray = firstNames.componentsSeparatedByString("|")
        let lastNames : String = "Ambers|Bishop|Cole|Danson|Evers|Frommer|Griswold|Heath|Jammers|Krause|Lehman|Myers|Neiman|Orsted|Paulson|Quaid|Richards|Stevens|Trask|Ulam"
        let lastNamesArray = lastNames.componentsSeparatedByString("|")
        let countries :String = "China|India|United States|Indonesia|Brazil|Pakistan|Bangladesh|Nigeria|Russia|Japan|Mexico|Philippines|Vietnam|Germany|Ethiopia|Egypt|Iran|Turkey|Congo|France|Thailand|United Kingdom|Italy|Myanmar"
        let countriesArray = countries.componentsSeparatedByString("|")
        let now = NSDate()
        var previousDate = NSDate()
        for var i = 0; i < total; i++ {
            previousDate = now.dateByAddingTimeInterval(-24 * 60 * 60 * Double(self.generateRandom(1000)))
            let customer = CustomerData(customerID: Double(i), countryID: Double(self.generateRandom(countriesArray.count)), performance: Double(self.generateRandom(101)), first: firstNamesArray[self.generateRandom(firstNamesArray.count)], last: lastNamesArray[self.generateRandom(lastNamesArray.count)], active: self.generateRandomBool(), hireDate: previousDate)
            array.addObject(customer)
        }
        return array
    }
}
