//
//  ViewController.swift
//  iOS9Xuni
//
//  Created by kelley.ricker on 9/16/15.
//  Copyright © 2015 kelley.ricker. All rights reserved.
//

import UIKit
import FlexChartKit
import FlexGridKit

class ViewController: UIViewController, UITextFieldDelegate {
    @IBOutlet weak var chart: FlexChart!
    @IBOutlet weak var grid: FlexGrid!
    @IBOutlet weak var inputField: UITextField!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        grid.isReadOnly = true
        inputField.delegate = self
        inputField.returnKeyType = UIReturnKeyType.Done
        inputField.keyboardType = UIKeyboardType.NumbersAndPunctuation
        populateChartandGrid(15)
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    func textFieldShouldBeginEditing(textField: UITextField) -> Bool {
        return true
    }
    func textFieldDidBeginEditing(textField: UITextField) {
        textField.selectAll(nil)
    }
    func textFieldShouldEndEditing(textField: UITextField) -> Bool {
        return true
    }
    func textFieldDidEndEditing(textField: UITextField) {
        populateChartandGrid((Int(textField.text!)!))
    }
    func populateChartandGrid(rowsToReturn : Int){
        var d = NSMutableArray()
        chart.series.removeAllObjects()
        do{
            //this is the code you will try to execute
            d = try CustomerData.getCustomerData(rowsToReturn)
            
        }
        catch CustomerData.Error.equalsZero{
            //a caught error
            inputField.text = "Please enter a value greater than zero"
        }
        catch CustomerData.Error.lessThanZero{
            //another caught error
            inputField.text = "Please enter a postive value greater than zero"
        }
        catch{
            //a catch all
            inputField.text = "Something unpredicted happened"
        }
        defer{
            //code that executes no matter what
        }
        grid.itemsSource = d
        chart.itemsSource = d
        let weightSeries = XuniSeries(forChart: chart, binding: "performance", name: "Performance")
        chart.series.addObject(weightSeries)
        chart.bindingX = "customerID"
    }
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        textField.resignFirstResponder()
        return true
    }

}

